package cn.com.taiji.cql.controller;


import cn.com.taiji.cql.model.GeoRequestParam;
import cn.com.taiji.cql.service.ITileService;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;

/**
 * 图层通用查询控制器
 *
 * @author makejava
 * @since 2021-04-22 16:53:35
 */
@Slf4j
@RestController
public class TileEcqlController {

    @Autowired
    private ITileService tileService;


    @RequestMapping(value = {"/queryTile"}, method = {RequestMethod.GET, RequestMethod.POST})
    public void queryTile(HttpServletRequest request, HttpServletResponse response) {


        GeoRequestParam geoRequestParam = JSONObject.parseObject(JSONObject.toJSONString(getParameterMap(request)), GeoRequestParam.class);

        byte[] ret = tileService.tileData(geoRequestParam);

        responseWrite(response, "image/png", ret);
    }

    private void responseWrite(HttpServletResponse response, String contentType, byte[] data) {

        response.setStatus(200);
        response.setContentType(contentType);

        if (data != null) {

            response.setContentLength(data.length);
            ServletOutputStream out = null;

            try {

                out = response.getOutputStream();
                out.write(data);
                out.flush();

            } catch (Exception e) {

                e.printStackTrace();

            } finally {

                if (out != null)
                    try {
                        out.close();
                    } catch (Exception e2) {

                        e2.printStackTrace();

                    }
            }
        }
    }

    /**
     * 将请求参数转化为Map
     *
     * @param request
     * @return
     */
    public static Map<String, Object> getParameterMap(HttpServletRequest request) {

        Map<String, Object> param = new HashMap<>();
        try {
            Enumeration<String> em = request.getParameterNames();
            while (em.hasMoreElements()) {
                String key = em.nextElement();
                param.put(key.toLowerCase(), request.getParameter(key));
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return param;
    }



}
