package cn.com.taiji.cql.service.impl;

import cn.com.taiji.cql.config.GeoConfig;
import cn.com.taiji.cql.service.IGeoDataSourceService;
import lombok.extern.slf4j.Slf4j;
import org.geotools.data.jdbc.datasource.DBCPDataSourceFactory;
import org.geotools.data.jdbc.datasource.DataSourceFinder;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import javax.sql.DataSource;
import java.util.HashMap;
import java.util.Map;

@Slf4j
@Service
public class GeoDataSourceServiceImpl implements IGeoDataSourceService {

    @Autowired
    private GeoConfig geoConfig;

    @Override
    public DataSource createGeoDataSource() throws Exception{


        //构建mysql数据库连接数据源--DataSource
        Map<String, Object> mapParams = new HashMap<String, Object>();
        mapParams.put(DBCPDataSourceFactory.DSTYPE.key, "DBCP");
        mapParams.put(DBCPDataSourceFactory.DRIVERCLASS.key, "com.mysql.cj.jdbc.Driver");
        mapParams.put(DBCPDataSourceFactory.JDBC_URL.key, "jdbc:mysql://"+geoConfig.getDsIp()+":"+geoConfig.getDsPort()+"/"+geoConfig.getDsBase()+"?useUnicode=true&characterEncoding=UTF-8&autoReconnect=true&useSSL=false&zeroDateTimeBehavior=convertToNull&serverTimezone=Asia/Shanghai");
        mapParams.put(DBCPDataSourceFactory.USERNAME.key, geoConfig.getDsUsername());
        mapParams.put(DBCPDataSourceFactory.PASSWORD.key, geoConfig.getDsPassword());
        mapParams.put(DBCPDataSourceFactory.MAXACTIVE.key, Integer.valueOf(10));
        mapParams.put(DBCPDataSourceFactory.MAXIDLE.key, Integer.valueOf(0));

        return DataSourceFinder.getDataSource(mapParams);
    }
}
